#4036 closed enhancement (fixed)

Track dependency command for the RSB

Reported by: Chris Johns Owned by: Chris Johns
Priority: normal Milestone: 6.1
Component: tool/rsb Version: 6
Severity: normal Keywords:
Cc: Blocked By:
Blocking:

Description

Add a command to track dependencies in the RSB. Scan all the bset files and see what they include. Build a list of dependencies and also a list of those configs that are not referenced. The configs not references can be removed.

Errors in build sets can result in an invalid list so the scan needs to be clean. This is difficult when some build sets like rtems-defaults.bset are designed to be included and not used from the command line. As a result it generates an error. A list of these could be maintained or a tag added to the bset file to indicate it is not a top level build set file.

Removal of unreferenced configs can occur in the RBS because we use a branch model for releases.

Change History (5)

comment:1 Changed on Aug 1, 2020 at 12:19:53 AM by Joel Sherrill

Is this going to result in a report that shows bsets and which source/patches they need?

Is it going to be something like this?

  • bset
    • another bset
      • source package
      • diff1

Or is the goal to look at a set of bsets and see what isn't needed?

comment:2 Changed on Aug 1, 2020 at 2:51:05 AM by Chris Johns

It could and yes the goal was to remove the config files not referenced. Up to now I was only looking at the list but the tree could be captured. This is nice addition.

A bset that is top level is difficult to remove because we do not know if it is being used.

comment:3 Changed on Aug 6, 2020 at 2:51:46 AM by Chris Johns

Owner: set to Chris Johns
Status: newassigned

Joel, is this what you wanted?

Include Tree(s):
 rtems/config/5/rtems-arm.bset
  rtems/config/5/rtems-default.bset
   bare/config/devel/expat-2.1.0-1.cfg
    source-builder/config/base.cfg
    source-builder/config/expat-2-1.cfg
   rtems/config/5/rtems-autotools.bset
    rtems/config/5/rtems-autotools-base.bset
     rtems/config/rtems-base.bset
      rtems/config/rtems-urls.bset
      rtems/config/rtems-version.bset
     rtems/config/tools/rtems-autoconf-2.69-1.cfg
      bare/config/devel/autoconf-2.69-1.cfg
       source-builder/config/autoconf-2-1.cfg
       source-builder/config/base.cfg
      source-builder/config/base.cfg
      source-builder/config/checks.cfg
      source-builder/config/versions.cfg
     rtems/config/tools/rtems-automake-1.12.6-1.cfg
      bare/config/devel/automake-1.12.6-1.cfg
       source-builder/config/automake-1-1.cfg
       source-builder/config/base.cfg
      source-builder/config/base.cfg
      source-builder/config/checks.cfg
      source-builder/config/versions.cfg
    rtems/config/5/rtems-autotools-internal.bset
     rtems/config/5/rtems-autotools-base.bset
      rtems/config/rtems-base.bset
       rtems/config/rtems-urls.bset
       rtems/config/rtems-version.bset
      rtems/config/tools/rtems-autoconf-2.69-1.cfg
       bare/config/devel/autoconf-2.69-1.cfg
        source-builder/config/autoconf-2-1.cfg
        source-builder/config/base.cfg
       source-builder/config/base.cfg
       source-builder/config/checks.cfg
       source-builder/config/versions.cfg
      rtems/config/tools/rtems-automake-1.12.6-1.cfg
       bare/config/devel/automake-1.12.6-1.cfg
        source-builder/config/automake-1-1.cfg
        source-builder/config/base.cfg
       source-builder/config/base.cfg
       source-builder/config/checks.cfg
       source-builder/config/versions.cfg
   rtems/config/rtems-base.bset
    rtems/config/rtems-urls.bset
    rtems/config/rtems-version.bset
   rtems/config/tools/rtems-binutils-2.34.cfg
    source-builder/config/base.cfg
    source-builder/config/binutils-2-1.cfg
     source-builder/config/checks.cfg
    source-builder/config/checks.cfg
   rtems/config/tools/rtems-gcc-7.5.0-newlib-7947581.cfg
    source-builder/config/base.cfg
    source-builder/config/checks.cfg
    source-builder/config/gcc-7.2-1.cfg
     source-builder/config/gcc-common-1.cfg
      source-builder/config/checks.cfg
   rtems/config/tools/rtems-gdb-9.1-1.cfg
    source-builder/config/base.cfg
    source-builder/config/checks.cfg
    source-builder/config/gdb-common-1.cfg
     source-builder/config/checks.cfg
   rtems/config/tools/rtems-tools-5-1.cfg
    rtems/config/tools/rtems-tools-common-1.cfg
Last edited on Aug 6, 2020 at 2:52:15 AM by Chris Johns (previous) (diff)

comment:4 Changed on Aug 10, 2020 at 11:03:11 PM by Chris Johns <chrisj@…>

Resolution: fixed
Status: assignedclosed

In 1241819/rtems-source-builder:

sb/track: Add a command to track build sets.

  • Process a build set for a range of hosts and output a dependency tree, the used build set and configuration files.
  • Output the configuration files that are no referenced

Closes #4036

comment:5 Changed on Aug 12, 2020 at 1:11:35 AM by Chris Johns <chrisj@…>

In 967999b/rtems-docs:

user: Add the RSB sb-track command

Updates #4036

Note: See TracTickets for help on using tickets.